#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include ".\mathStuff.h"

enum FORMSTYLE{F_BORDERED,F_BORDERLESS};

//////a window class//////
class WindowClass
{
private:
	//default window data
	HDC hdc;			//device context handle for window
	HWND hWnd;			//window Handle
	HINSTANCE hInst;	//instance
	RECT rect;			//client rectangle
	char *szTitle;		//title bar text
	char *szWindowClass;//class name
	WNDCLASSEX wcex;	

	//data for window brushes and backbuffer
	HDC bufferDC;		//device context handle for buffer
	HBITMAP bufferBMP,	//buffer bitmap
			tmpBMP;		//temporary bitmap
	HBRUSH backBrush,	//background brush
		   foreBrush;	//foreground brush
	long Color_back;	//obvious stuff
	long Color_fore;
	
	//window position data;
	RECT position;		//window rectangle in screen coords
	int width,height;	//window width, height in screen coords
	
	//tells you if the initInstance function has been called
	bool windowLoaded;

	//crazy private function to handle window resize
	void recreateBuffer();

public:
	//constructor
	WindowClass();
	
	//basic window class functions
	void WindowCaption(char *windowName);
	HINSTANCE Instance();
	void Icon(LPCTSTR IconName);
	void IconSmall(LPCTSTR IconName);
	void Cursor(LPCTSTR CursorName);
	void ClassName(char *classname);
	void InitData(HINSTANCE hInstance,WNDPROC myWndProc,
				  long backcolor, long forecolor,
				  int left,int top,int width, int height);
	BOOL InitInstance(HINSTANCE, int,FORMSTYLE );
	
	//window position functions
	void wLeft(int leftval);
	void wTop (int topval);
	void wWidth(int widthval);
	void wHeight(int heightval);

	int wLeft();
	int wTop ();
	int wWidth();
	int wHeight();
	int clientLeft();
	int clientTop();
	void updateWindowPos();

	//window drawing and backbuffer functions
	void backColor(long );
	void foreColor(long );
	long backColor();
	long foreColor();
	
	void printText(LPCTSTR lpstring,int xpos,int ypos);

	void drawBuffer();
	void cls();
	
	HDC GetBufferDC();
	HDC GetWindowDC();
	HWND GetHandle();	//returns hWnd of window

	//function to prevent mouse movement outside window
	POINT wCaptureMouse(int,int);

	//call this in response to WM_DESTROY/WM_QUIT
	void destroyMe();
};


///////////a timer class/////////
class TimerClass
{
protected:
	DWORD interval;	//time interval (milliseconds)
	DWORD oldTime;	//local variable for comparision
	static float speedXplier; //multiplier for all timer speeds

public:
	DWORD getInterval();
	void setInterval(DWORD);
	bool Elapsed();

	static float getSpeedXplier()
	{	return speedXplier;
	}

	static void setSpeedXplier(float value)
	{	speedXplier=value;
	}

};


/////MultiThreaded timer/////////
class TimerClassMT : public TimerClass
{
private:
	LPDWORD ThreadID;
	HANDLE hThread;
	void (* targetFn)();
	bool running;
	bool suppressed;
	static int numThreads;
public:

	TimerClassMT();
	void TimerLoop();
	bool isrunning();
	void StartTimer(void (* lpStartAddress)());
	void EndTimer();
	bool& Suppressed();

	static int threadCount()
	{	return numThreads;	
	}

	static void ThreadStarter(TimerClassMT * srcClass)
	{	srcClass->TimerLoop();
	}
};

/////// image class//////

class ImageClass
{
private:
	HDC imageDC;
	HBITMAP imageBMP,old1;
	HDC maskDC;
	HBITMAP maskBMP,old2;
	int width;
	int height;
	int frameWidth,frameHeight;
	bool isReference;

protected:
	int framesX,framesY;
	int animSpeed;
	bool hasMask;
	bool fileLoaded;

public:
	ImageClass();
	ImageClass(ImageClass& srcImage);
	~ImageClass();
	bool loadPic(LPCTSTR fname,int _width,int _height,
		         int _framesX,int _framesY, WindowClass * window);
	bool ImageClass::loadMask(LPCTSTR fname,WindowClass * window);
	int getWidth();
	int getHeight();
	int getFrameWidth();
	int getFrameHeight();
	int getNumFramesX();
	int getNumFramesY();
	void delPic();
	bool Reference();
	bool Masked();
	void makeReference(ImageClass srcImage);//the reference shares
											//same memory as source

	ImageClass operator = (ImageClass srcImage);//makes an independent copy of source

	void drawPic(HDC dest,int x,int y,int _frameX,int _frameY, bool masked);
};


class ImageText : public ImageClass
{
private:
	char charlist[70];
public:
void loadFont(LPCTSTR fname,int width,int height,
			  char* list,WindowClass * window);
void drawText(char* text,HDC hdc,int xpos,int ypos);
};


